// Copyright 2019-2024 Yuji Tanaka
// HP : http://galaxystar.image.coocan.jp/
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
#include <SPI.h>
#include <Adafruit_GFX.h>
#include <ILI9163.h>
#include <WiFi.h>

const char* ssid     = "aterm-c17543-g";
const char* password = "181411c5886cb";

char title_html[]=
"<!DOCTYPE html><html lang='ja'><head><meta charset='UTF-8'>\
<meta http-equiv='refresh' content='5'/>\
<style>input {margin:4px;width:200px;}\
norm {font-size:12pt;color:black;}\
div {font-size:16pt;color:red;text-align:center;width:340px;border:groove 40px orange;}</style>\
<title>WiFi_Othello</title></head>\
<body><div><p>WiFi Othello</p>\
<form method='get'>\
<input type='submit' name='t1' value='Human vs Human' /><br>\
<input type='submit' name='t2' value='Human vs Computer1' /><br>\
<input type='submit' name='t3' value='Human vs Computer2' /><br>\
<input type='submit' name='t4' value='Human vs Computer3' /><br>\
<input type='submit' name='t5' value='Human vs Computer4' /><br>\
</form></div></body></html>";

char sente_html[]=
"<!DOCTYPE html><html lang='ja'><head><meta charset='UTF-8'>\
<meta http-equiv='refresh' content='5'/>\
<style>input {margin:4px;width:200px;}\
norm {font-size:12pt;color:black;}\
div {font-size:16pt;color:red;text-align:center;width:340px;border:groove 40px orange;}</style>\
<title>WiFi_Othello</title></head>\
<body><div><p>WiFi Othello</p>\
<form method='get'>\
<input type='submit' name='s1' value='First' /><br>\
<input type='submit' name='s2' value='Second' /><br>\
</form></div></body></html>";

char html[]=
"<!DOCTYPE html><html lang='ja'><head><meta charset='UTF-8'>\
<meta http-equiv='refresh' content='5'/>\
<style>input {margin:4px;width:30px;}\
norm {font-size:12pt;color:black;}\
div {font-size:16pt;color:red;text-align:center;width:340px;border:groove 40px orange;}</style>\
<title>WiFi_Othello</title></head>\
<body><div><p>WiFi Othello</p>\
<norm><p>Next : @</p>\
<p>  @ =   </p>\
<p>  O =   </p></norm>\
<form method='get'>\
<input type='submit' name='a1' value=' ' />\
<input type='submit' name='a2' value=' ' />\
<input type='submit' name='a3' value=' ' />\
<input type='submit' name='a4' value=' ' />\
<input type='submit' name='a5' value=' ' />\
<input type='submit' name='a6' value=' ' />\
<input type='submit' name='a7' value=' ' />\
<input type='submit' name='a8' value=' ' /><br>\
<input type='submit' name='b1' value=' ' />\
<input type='submit' name='b2' value=' ' />\
<input type='submit' name='b3' value=' ' />\
<input type='submit' name='b4' value=' ' />\
<input type='submit' name='b5' value=' ' />\
<input type='submit' name='b6' value=' ' />\
<input type='submit' name='b7' value=' ' />\
<input type='submit' name='b8' value=' ' /><br>\
<input type='submit' name='c1' value=' ' />\
<input type='submit' name='c2' value=' ' />\
<input type='submit' name='c3' value=' ' />\
<input type='submit' name='c4' value=' ' />\
<input type='submit' name='c5' value=' ' />\
<input type='submit' name='c6' value=' ' />\
<input type='submit' name='c7' value=' ' />\
<input type='submit' name='c8' value=' ' /><br>\
<input type='submit' name='d1' value=' ' />\
<input type='submit' name='d2' value=' ' />\
<input type='submit' name='d3' value=' ' />\
<input type='submit' name='d4' value=' ' />\
<input type='submit' name='d5' value=' ' />\
<input type='submit' name='d6' value=' ' />\
<input type='submit' name='d7' value=' ' />\
<input type='submit' name='d8' value=' ' /><br>\
<input type='submit' name='e1' value=' ' />\
<input type='submit' name='e2' value=' ' />\
<input type='submit' name='e3' value=' ' />\
<input type='submit' name='e4' value=' ' />\
<input type='submit' name='e5' value=' ' />\
<input type='submit' name='e6' value=' ' />\
<input type='submit' name='e7' value=' ' />\
<input type='submit' name='e8' value=' ' /><br>\
<input type='submit' name='f1' value=' ' />\
<input type='submit' name='f2' value=' ' />\
<input type='submit' name='f3' value=' ' />\
<input type='submit' name='f4' value=' ' />\
<input type='submit' name='f5' value=' ' />\
<input type='submit' name='f6' value=' ' />\
<input type='submit' name='f7' value=' ' />\
<input type='submit' name='f8' value=' ' /><br>\
<input type='submit' name='g1' value=' ' />\
<input type='submit' name='g2' value=' ' />\
<input type='submit' name='g3' value=' ' />\
<input type='submit' name='g4' value=' ' />\
<input type='submit' name='g5' value=' ' />\
<input type='submit' name='g6' value=' ' />\
<input type='submit' name='g7' value=' ' />\
<input type='submit' name='g8' value=' ' /><br>\
<input type='submit' name='h1' value=' ' />\
<input type='submit' name='h2' value=' ' />\
<input type='submit' name='h3' value=' ' />\
<input type='submit' name='h4' value=' ' />\
<input type='submit' name='h5' value=' ' />\
<input type='submit' name='h6' value=' ' />\
<input type='submit' name='h7' value=' ' />\
<input type='submit' name='h8' value=' ' />\
</form></div></body></html>";

char finish_html[]=
"<!DOCTYPE html><html lang='ja'><head><meta charset='UTF-8'>\
<meta http-equiv='refresh' content='5'/>\
<style>input {margin:4px;width:30px;}\
input2 {margin:4px;width:100px;}\
norm {font-size:12pt;color:black;}\
div {font-size:16pt;color:red;text-align:center;width:340px;border:groove 40px orange;}</style>\
<title>WiFi_Othello</title></head>\
<body><div><p>WiFi Othello</p>\
<norm><p>  @ =   </p>\
<p>  O =   </p></norm>\
<p>Finish</p>\
<form method='get'>\
<input type='submit' name='fin' value='OK' /><br>\
<input type='submit' name='a1' value=' ' />\
<input type='submit' name='a2' value=' ' />\
<input type='submit' name='a3' value=' ' />\
<input type='submit' name='a4' value=' ' />\
<input type='submit' name='a5' value=' ' />\
<input type='submit' name='a6' value=' ' />\
<input type='submit' name='a7' value=' ' />\
<input type='submit' name='a8' value=' ' /><br>\
<input type='submit' name='b1' value=' ' />\
<input type='submit' name='b2' value=' ' />\
<input type='submit' name='b3' value=' ' />\
<input type='submit' name='b4' value=' ' />\
<input type='submit' name='b5' value=' ' />\
<input type='submit' name='b6' value=' ' />\
<input type='submit' name='b7' value=' ' />\
<input type='submit' name='b8' value=' ' /><br>\
<input type='submit' name='c1' value=' ' />\
<input type='submit' name='c2' value=' ' />\
<input type='submit' name='c3' value=' ' />\
<input type='submit' name='c4' value=' ' />\
<input type='submit' name='c5' value=' ' />\
<input type='submit' name='c6' value=' ' />\
<input type='submit' name='c7' value=' ' />\
<input type='submit' name='c8' value=' ' /><br>\
<input type='submit' name='d1' value=' ' />\
<input type='submit' name='d2' value=' ' />\
<input type='submit' name='d3' value=' ' />\
<input type='submit' name='d4' value=' ' />\
<input type='submit' name='d5' value=' ' />\
<input type='submit' name='d6' value=' ' />\
<input type='submit' name='d7' value=' ' />\
<input type='submit' name='d8' value=' ' /><br>\
<input type='submit' name='e1' value=' ' />\
<input type='submit' name='e2' value=' ' />\
<input type='submit' name='e3' value=' ' />\
<input type='submit' name='e4' value=' ' />\
<input type='submit' name='e5' value=' ' />\
<input type='submit' name='e6' value=' ' />\
<input type='submit' name='e7' value=' ' />\
<input type='submit' name='e8' value=' ' /><br>\
<input type='submit' name='f1' value=' ' />\
<input type='submit' name='f2' value=' ' />\
<input type='submit' name='f3' value=' ' />\
<input type='submit' name='f4' value=' ' />\
<input type='submit' name='f5' value=' ' />\
<input type='submit' name='f6' value=' ' />\
<input type='submit' name='f7' value=' ' />\
<input type='submit' name='f8' value=' ' /><br>\
<input type='submit' name='g1' value=' ' />\
<input type='submit' name='g2' value=' ' />\
<input type='submit' name='g3' value=' ' />\
<input type='submit' name='g4' value=' ' />\
<input type='submit' name='g5' value=' ' />\
<input type='submit' name='g6' value=' ' />\
<input type='submit' name='g7' value=' ' />\
<input type='submit' name='g8' value=' ' /><br>\
<input type='submit' name='h1' value=' ' />\
<input type='submit' name='h2' value=' ' />\
<input type='submit' name='h3' value=' ' />\
<input type='submit' name='h4' value=' ' />\
<input type='submit' name='h5' value=' ' />\
<input type='submit' name='h6' value=' ' />\
<input type='submit' name='h7' value=' ' />\
<input type='submit' name='h8' value=' ' />\
</form></div></body></html>";

WiFiServer server(80);

#define TFT_DC 48
#define TFT_CS 47
#define TFT_RST 45

ILI9163 tft = ILI9163(TFT_CS, TFT_DC, TFT_RST);

#define XMAX 128
#define YMAX 160
#define STARTX 0
#define STARTY 16
#define SIZEX 128
#define SIZEY 144
#define SIZE 14

static int state;
static int oth_mode;
static int ban;
static int sente;
static int komasuu;
static int latest_x, latest_y;
char board[8][8];

void setup()
{
    int x, y;

    Serial.begin(115200);

    tft.begin();
    tft.setRotation(2);
    tft.fillScreen(ILI9163_BLACK);

    delay(10);
  
    Serial.println();
    Serial.println();
    Serial.print("Connecting to ");
    Serial.println(ssid);

    tft.setTextColor(ILI9163_WHITE);
    tft.setCursor(0,0);
    tft.print(ssid);

    WiFi.begin(ssid, password);

    while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.print(".");
    }

    Serial.println("");
    Serial.println("WiFi connected.");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());
    
    tft.setCursor(0,8);
    tft.print(WiFi.localIP());

    server.begin();

    state=0;
}

void loop(){
  int x, y;
  int mx, my;

  if (state==0){
    showTitle();
    state=1;
  }else if (state==2){
    showSente();
    state=3;
  }else if (state==6){
    showEnd();
    state=7;
  }

  if (state==5 && oth_mode>0){
    // Computer
    if ((sente==1 && ban==2) || (sente==0 && ban==1)){
      think(&board[0][0], &x, &y, ban, oth_mode);
      if (put_on_board(&board[0][0], x, y, ban)){
        latest_x=x;
        latest_y=y;
        komasuu++;
        if (ban==1)
          ban=2;
        else
          ban=1;
        show_board(&board[0][0], oth_mode);
      }
      // Cannot put
      if (put_num(&board[0][0], ban)==0){
        if (ban==1)
          ban=2;
        else
          ban=1;
        // Finish
        if (put_num(&board[0][0], ban)==0)
          state=6;
      }
      return;
    }
  }

  WiFiClient client = server.available();

  if (client) {
    Serial.println("New Client.");
    String currentLine = "";
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        Serial.write(c);
        if (c == '\n') {
          if (currentLine.length() == 0) {
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println();
            if (state==0 || state==1)
              client.print(title_html);
            else if (state==2 || state==3)
              client.print(sente_html);
            else if (state==6 || state==7)
              client.print(finish_html);
            else
              client.println(html);
            break;
          } else {
            currentLine = "";
          }
        } else if (c != '\r') {
          currentLine += c;
        }

        if (state==1 && currentLine.endsWith("GET /?t1")) {
          oth_mode=0;
          state=4;
        }
        if (state==1 && currentLine.endsWith("GET /?t2")) {
          oth_mode=1;
          state=2;
        }
        if (state==1 && currentLine.endsWith("GET /?t3")) {
          oth_mode=2;
          state=2;
        }
        if (state==1 && currentLine.endsWith("GET /?t4")) {
          oth_mode=3;
          state=2;
        }
        if (state==1 && currentLine.endsWith("GET /?t5")) {
          oth_mode=4;
          state=2;
        }

        if (state==3 && currentLine.endsWith("GET /?s1")) {
          sente=1;
          state=4;
        }
        if (state==3 && currentLine.endsWith("GET /?s2")) {
          sente=0;
          state=4;
        }
        if (state==4){
          for(y=0;y<8;y++)
            for(x=0;x<8;x++)
              board[y][x]=0;
          board[3][3]=1;
          board[4][4]=1;
          board[3][4]=2;
          board[4][3]=2;
          ban=1;
          komasuu=4;
          latest_x=-1;
          latest_y=-1;
          show_board(&board[0][0], oth_mode);
          state=5;
        }

        if ((state==6 || state==7) && currentLine.endsWith("GET /?fin")) {
          state=0;
        }

        mx=-1;
        my=-1;
        if (currentLine.endsWith("GET /?a1")) {
          mx=0;
          my=0;
        }
        if (currentLine.endsWith("GET /?a2")) {
          mx=1;
          my=0;
        }
        if (currentLine.endsWith("GET /?a3")) {
          mx=2;
          my=0;
        }
        if (currentLine.endsWith("GET /?a4")) {
          mx=3;
          my=0;
        }
        if (currentLine.endsWith("GET /?a5")) {
          mx=4;
          my=0;
        }
        if (currentLine.endsWith("GET /?a6")) {
          mx=5;
          my=0;
        }
        if (currentLine.endsWith("GET /?a7")) {
          mx=6;
          my=0;
        }
        if (currentLine.endsWith("GET /?a8")) {
          mx=7;
          my=0;
        }
        if (currentLine.endsWith("GET /?b1")) {
          mx=0;
          my=1;
        }
        if (currentLine.endsWith("GET /?b2")) {
          mx=1;
          my=1;
        }
        if (currentLine.endsWith("GET /?b3")) {
          mx=2;
          my=1;
        }
        if (currentLine.endsWith("GET /?b4")) {
          mx=3;
          my=1;
        }
        if (currentLine.endsWith("GET /?b5")) {
          mx=4;
          my=1;
        }
        if (currentLine.endsWith("GET /?b6")) {
          mx=5;
          my=1;
        }
        if (currentLine.endsWith("GET /?b7")) {
          mx=6;
          my=1;
        }
        if (currentLine.endsWith("GET /?b8")) {
          mx=7;
          my=1;
        }
        if (currentLine.endsWith("GET /?c1")) {
          mx=0;
          my=2;
        }
        if (currentLine.endsWith("GET /?c2")) {
          mx=1;
          my=2;
        }
        if (currentLine.endsWith("GET /?c3")) {
          mx=2;
          my=2;
        }
        if (currentLine.endsWith("GET /?c4")) {
          mx=3;
          my=2;
        }
        if (currentLine.endsWith("GET /?c5")) {
          mx=4;
          my=2;
        }
        if (currentLine.endsWith("GET /?c6")) {
          mx=5;
          my=2;
        }
        if (currentLine.endsWith("GET /?c7")) {
          mx=6;
          my=2;
        }
        if (currentLine.endsWith("GET /?c8")) {
          mx=7;
          my=2;
        }
        if (currentLine.endsWith("GET /?d1")) {
          mx=0;
          my=3;
        }
        if (currentLine.endsWith("GET /?d2")) {
          mx=1;
          my=3;
        }
        if (currentLine.endsWith("GET /?d3")) {
          mx=2;
          my=3;
        }
        if (currentLine.endsWith("GET /?d4")) {
          mx=3;
          my=3;
        }
        if (currentLine.endsWith("GET /?d5")) {
          mx=4;
          my=3;
        }
        if (currentLine.endsWith("GET /?d6")) {
          mx=5;
          my=3;
        }
        if (currentLine.endsWith("GET /?d7")) {
          mx=6;
          my=3;
        }
        if (currentLine.endsWith("GET /?d8")) {
          mx=7;
          my=3;
        }
        if (currentLine.endsWith("GET /?e1")) {
          mx=0;
          my=4;
        }
        if (currentLine.endsWith("GET /?e2")) {
          mx=1;
          my=4;
        }
        if (currentLine.endsWith("GET /?e3")) {
          mx=2;
          my=4;
        }
        if (currentLine.endsWith("GET /?e4")) {
          mx=3;
          my=4;
        }
        if (currentLine.endsWith("GET /?e5")) {
          mx=4;
          my=4;
        }
        if (currentLine.endsWith("GET /?e6")) {
          mx=5;
          my=4;
        }
        if (currentLine.endsWith("GET /?e7")) {
          mx=6;
          my=4;
        }
        if (currentLine.endsWith("GET /?e8")) {
          mx=7;
          my=4;
        }
        if (currentLine.endsWith("GET /?f1")) {
          mx=0;
          my=5;
        }
        if (currentLine.endsWith("GET /?f2")) {
          mx=1;
          my=5;
        }
        if (currentLine.endsWith("GET /?f3")) {
          mx=2;
          my=5;
        }
        if (currentLine.endsWith("GET /?f4")) {
          mx=3;
          my=5;
        }
        if (currentLine.endsWith("GET /?f5")) {
          mx=4;
          my=5;
        }
        if (currentLine.endsWith("GET /?f6")) {
          mx=5;
          my=5;
        }
        if (currentLine.endsWith("GET /?f7")) {
          mx=6;
          my=5;
        }
        if (currentLine.endsWith("GET /?f8")) {
          mx=7;
          my=5;
        }
        if (currentLine.endsWith("GET /?g1")) {
          mx=0;
          my=6;
        }
        if (currentLine.endsWith("GET /?g2")) {
          mx=1;
          my=6;
        }
        if (currentLine.endsWith("GET /?g3")) {
          mx=2;
          my=6;
        }
        if (currentLine.endsWith("GET /?g4")) {
          mx=3;
          my=6;
        }
        if (currentLine.endsWith("GET /?g5")) {
          mx=4;
          my=6;
        }
        if (currentLine.endsWith("GET /?g6")) {
          mx=5;
          my=6;
        }
        if (currentLine.endsWith("GET /?g7")) {
          mx=6;
          my=6;
        }
        if (currentLine.endsWith("GET /?g8")) {
          mx=7;
          my=6;
        }
        if (currentLine.endsWith("GET /?h1")) {
          mx=0;
          my=7;
        }
        if (currentLine.endsWith("GET /?h2")) {
          mx=1;
          my=7;
        }
        if (currentLine.endsWith("GET /?h3")) {
          mx=2;
          my=7;
        }
        if (currentLine.endsWith("GET /?h4")) {
          mx=3;
          my=7;
        }
        if (currentLine.endsWith("GET /?h5")) {
          mx=4;
          my=7;
        }
        if (currentLine.endsWith("GET /?h6")) {
          mx=5;
          my=7;
        }
        if (currentLine.endsWith("GET /?h7")) {
          mx=6;
          my=7;
        }
        if (currentLine.endsWith("GET /?h8")) {
          mx=7;
          my=7;
        }
        if (state==5 && mx>=0 && my>=0){
          x=mx;
          y=my;
          if (0<=x && x<8 && 0<=y && y<8){
            if (put_on_board(&board[0][0], x, y, ban)){
              latest_x=x;
              latest_y=y;
              komasuu++;

              if (ban==1)
                ban=2;
              else
                ban=1;
            }
            // Cannot put
            if (put_num(&board[0][0], ban)==0){
              if (ban==1)
                ban=2;
              else
                ban=1;
              // Finish
              if (put_num(&board[0][0], ban)==0)
                state=6;
            }
            show_board(&board[0][0], oth_mode);
          }
        }
      }
    }
    client.stop();
    Serial.println("Client Disconnected.");
  }
}

void set_html(int x, int y, int val)
{
  int i;
  char dat0, dat1;

  if (x<0){
    if (y==0){
      for(i=0;html[i]!='\0';i++){
        if (html[i]=='N' && html[i+1]=='e' && html[i+2]=='x' && html[i+3]=='t'){
          if (val==1)
            html[i+7]='@';
          else if (val==2)
            html[i+7]='O';
          else
            html[i+7]=' ';
          break;
        }
      }
    }else if (y==1){
      for(i=0;html[i]!='\0';i++){
        if (html[i]=='@' && html[i+1]==' ' && html[i+2]=='='){
          html[i+4]=(val<10) ? ' ' : '0'+val/10;
          html[i+5]='0'+val % 10;
          break;
        }
      }
    }else{
      for(i=0;html[i]!='\0';i++){
        if (html[i]=='O' && html[i+1]==' ' && html[i+2]=='='){
          html[i+4]=(val<10) ? ' ' : '0'+val/10;
          html[i+5]='0'+val % 10;
          break;
        }
      }
    }
    return;
  }
  
  dat0='a'+y;
  dat1='1'+x;

  for(i=0;html[i]!='\0';i++){
    if (html[i]=='\'' && html[i+1]==dat0 && html[i+2]==dat1 && html[i+3]=='\''){
      if (val==1)
        html[i+12]='@';
      else if (val==2)
        html[i+12]='O';
      else
        html[i+12]=' ';
    }
  }
}

void set_finish_html(int x, int y, int val)
{
  int i;
  char dat0, dat1;

  if (x<0){
    if (y==1){
      for(i=0;finish_html[i]!='\0';i++){
        if (finish_html[i]=='@' && finish_html[i+1]==' ' && finish_html[i+2]=='='){
          finish_html[i+4]=(val<10) ? ' ' : '0'+val/10;
          finish_html[i+5]='0'+val % 10;
          break;
        }
      }
    }else{
      for(i=0;finish_html[i]!='\0';i++){
        if (finish_html[i]=='O' && finish_html[i+1]==' ' && finish_html[i+2]=='='){
          finish_html[i+4]=(val<10) ? ' ' : '0'+val/10;
          finish_html[i+5]='0'+val % 10;
          break;
        }
      }
    }
    return;
  }
  
  dat0='a'+y;
  dat1='1'+x;

  for(i=0;finish_html[i]!='\0';i++){
    if (finish_html[i]=='\'' && finish_html[i+1]==dat0 && finish_html[i+2]==dat1 && finish_html[i+3]=='\''){
      if (val==1)
        finish_html[i+12]='@';
      else if (val==2)
        finish_html[i+12]='O';
      else
        finish_html[i+12]=' ';
    }
  }
}

void showTitle()
{
  tft.fillRect(STARTX, STARTY, SIZEX, SIZEY, ILI9163_BLACK);
  tft.setTextSize(1);
  tft.setTextColor(ILI9163_GREEN);
  tft.setCursor(STARTX, STARTY+8);
  tft.print("Othello");

  tft.setTextSize(1);
  tft.setTextColor(ILI9163_WHITE);
  tft.setCursor(0, STARTY+SIZEY*3/8);
  tft.print("Human vs Human");
  tft.setCursor(0, STARTY+SIZEY*4/8);
  tft.print("Human vs Computer1");
  tft.setCursor(0, STARTY+SIZEY*5/8);
  tft.print("Human vs Computer2");
  tft.setCursor(0, STARTY+SIZEY*6/8);
  tft.print("Human vs Computer3");
  tft.setCursor(0, STARTY+SIZEY*7/8);
  tft.print("Human vs Computer4");
}

void showSente()
{
  tft.fillRect(STARTX, STARTY, SIZEX, SIZEY, ILI9163_BLACK);
  tft.setTextSize(1);
  tft.setTextColor(ILI9163_RED);
  tft.setCursor(STARTX, STARTY+8);
  tft.print("Select order");

  tft.setTextSize(1);
  tft.setTextColor(ILI9163_WHITE);
  tft.setCursor(32, STARTY+SIZEY*3/8);
  tft.print("1.First");
  tft.setCursor(32, STARTY+SIZEY*4/8);
  tft.print("2.Second");
}

void showEnd()
{
  show_board(&board[0][0], oth_mode+8);
}

void show_board(char *bd, int mm)
{
  int x, y;
  int sx, sy;
  char str[32];
  sx=STARTX;
  sy=YMAX-1-SIZE*8;

  tft.fillRect(STARTX, STARTY, SIZEX, SIZEY, ILI9163_DARKGREY);
  tft.fillRect(sx, sy, 8*SIZE, 8*SIZE, ILI9163_GREEN);
  if (latest_x>=0 && latest_y>=0)
    tft.fillRect(sx+latest_x*SIZE+1, sy+latest_y*SIZE+1, SIZE-1, SIZE-1, ILI9163_RED);
  for(x=0;x<=8;x++){
    tft.drawLine(sx+x*SIZE, sy, sx+x*SIZE, sy+8*SIZE, ILI9163_WHITE);
    tft.drawLine(sx, sy+x*SIZE, sx+8*SIZE, sy+x*SIZE, ILI9163_WHITE);
  }
  for(y=0;y<8;y++){
    for(x=0;x<8;x++){
      if (bd[y*8+x]==1)
        tft.fillCircle(sx+x*SIZE+SIZE/2, sy+y*SIZE+SIZE/2, SIZE/2-2, ILI9163_BLACK);
      else if (bd[y*8+x]==2)
        tft.fillCircle(sx+x*SIZE+SIZE/2, sy+y*SIZE+SIZE/2, SIZE/2-2, ILI9163_WHITE);
    }
  }

  tft.setTextSize(1);
  tft.setTextColor(ILI9163_RED);
  tft.setCursor(STARTX, STARTY);
  if (mm % 8==0)
    tft.print("Human vs Human");
  if (mm % 8==1)
    if (sente==1)
      tft.print("Human vs Comp1");
    else
      tft.print("Comp1 vs Human");
  if (mm % 8==2)
    if (sente==1)
      tft.print("Human vs Comp2");
    else
      tft.print("Comp2 vs Human");
  if (mm % 8==3)
    if (sente==1)
      tft.print("Human vs Comp3");
    else
      tft.print("Comp3 vs Human");
  if (mm % 8==4)
    if (sente==1)
      tft.print("Human vs Comp4");
    else
      tft.print("Comp4 vs Human");

  tft.fillCircle(STARTX+SIZE*6+SIZE/2, STARTY+8,  4, ILI9163_BLACK);
  tft.fillCircle(STARTX+SIZE*6+SIZE/2, STARTY+20, 4, ILI9163_WHITE);
  tft.setTextSize(1);
  tft.setTextColor(ILI9163_WHITE);
  tft.setCursor(STARTX+SIZE*7, STARTY+4);
  sprintf(str, "%d", count_point(bd, 1));
  tft.print(str);
  tft.setCursor(STARTX+SIZE*7, STARTY+16);
  sprintf(str, "%d", count_point(bd, 2));
  tft.print(str);

  if (mm<8){
    if (ban==1)
      tft.fillCircle(SIZE*4,STARTY+20, 4, ILI9163_BLACK);
    else
      tft.fillCircle(SIZE*4,STARTY+20, 4, ILI9163_WHITE);

    tft.setTextSize(1);
    tft.setTextColor(ILI9163_WHITE);
    tft.setCursor(SIZE*3/2, STARTY+16);
    tft.print("Next");
  }else{
    tft.setTextColor(ILI9163_BLUE);
    tft.setCursor(XMAX-36, STARTY);
    tft.print("Finish");
  }

  // HTML board
  for(y=0;y<8;y++)
    for(x=0;x<8;x++){
      set_html(x, y, board[y][x]);
      set_finish_html(x, y, board[y][x]);
    }
  // HTML Next
  set_html(-1, 0, ban);
  // HTML Point
  set_html(-1, 1, count_point(bd, 1));
  set_html(-1, 2, count_point(bd, 2));
  set_finish_html(-1, 1, count_point(bd, 1));
  set_finish_html(-1, 2, count_point(bd, 2));
}

int count_point(char *bd, int c)
{
  int rx, ry;
  int num;
  num=0;
  for(ry=0;ry<8;ry++)
    for(rx=0;rx<8;rx++)
      if(bd[ry*8+rx]==c)
        num++;
  return num;
}

bool can_put(char *bd,int x,int y,int c)
{
  int rx,ry,rc;
  bool do_rev;
  do_rev=false;
  if(bd[y*8+x]!=0)
          return(do_rev);
  if(c==1) rc=2;
        else  rc=1;
// up
  rx=x;
  ry=y-1;
    for(;;){
    if(ry<0 || bd[ry*8+rx]!=rc)
      break;
    ry--;
    if(ry>=0 && bd[ry*8+rx]==c)
      return true;
  }
// down
  rx=x;
  ry=y+1;
    for(;;){
    if(ry>=8 || bd[ry*8+rx]!=rc)
      break;
    ry++;
    if(ry<8 && bd[ry*8+rx]==c)
      return true;
  }
// left
  rx=x-1;
  ry=y;
    for(;;){
    if(rx<0 || bd[ry*8+rx]!=rc)
      break;
    rx--;
    if(rx>=0 && bd[ry*8+rx]==c)
      return true;
  }
// right
  rx=x+1;
  ry=y;
    for(;;){
    if(rx>=8 || bd[ry*8+rx]!=rc)
      break;
    rx++;
    if(rx<8 && bd[ry*8+rx]==c)
      return true;
  }
// up-left
  rx=x-1;
  ry=y-1;
    for(;;){
    if(rx<0 || ry<0 || bd[ry*8+rx]!=rc)
      break;
    rx--;
    ry--;
    if(rx>=0 && ry>=0 && bd[ry*8+rx]==c)
      return true;
  }
// down-left
  rx=x-1;
  ry=y+1;
    for(;;){
    if(rx<0 || ry>=8 || bd[ry*8+rx]!=rc)
      break;
    rx--;
    ry++;
    if(rx>=0 && ry<8 && bd[ry*8+rx]==c)
      return true;
  }
// up-right
  rx=x+1;
  ry=y-1;
    for(;;){
    if(rx>=8 || ry<0 || bd[ry*8+rx]!=rc)
      break;
    rx++;
    ry--;
    if(rx<8 && ry>=0 && bd[ry*8+rx]==c)
      return true;
  }
// down-right
  rx=x+1;
  ry=y+1;
    for(;;){
    if(rx>=8 || ry>=8 || bd[ry*8+rx]!=rc)
      break;
    rx++;
    ry++;
    if(rx<8 && ry<8 && bd[ry*8+rx]==c)
      return true;
  }
  return false;
}

int put_num(char *bd,int c)
{
  int x,y,rx,ry,rc,num;
  int i;
  num=0;
  if(c==1) rc=2;
    else  rc=1;

  for(y=0;y<8;y++){
        for(x=0;x<8;x++){
          if(bd[y*8+x]!=0)
            continue;
// up
          rx=x;
          ry=y-1;
          for(;;){
            if(ry<0 || bd[ry*8+rx]!=rc)
              break;
            ry--;
            if(ry>=0 && bd[ry*8+rx]==c){
              num++;
                    goto loop_end;
            }
          }
// down
          rx=x;
          ry=y+1;
          for(;;){
            if(ry>=8 || bd[ry*8+rx]!=rc)
              break;
            ry++;
            if(ry<8 && bd[ry*8+rx]==c){
              num++;
              goto loop_end;
            }
          }
// left
          rx=x-1;
          ry=y;
          for(;;){
            if(rx<0 || bd[ry*8+rx]!=rc)
              break;
            rx--;
            if(rx>=0 && bd[ry*8+rx]==c){
              num++;
              goto loop_end;
            }
          }
// right
          rx=x+1;
          ry=y;
          for(;;){
            if(rx>=8 || bd[ry*8+rx]!=rc)
              break;
            rx++;
            if(rx<8 && bd[ry*8+rx]==c){
              num++;
              goto loop_end;
            }
          }
// up-left
          rx=x-1;
          ry=y-1;
          for(;;){
            if(rx<0 || ry<0 || bd[ry*8+rx]!=rc)
              break;
            rx--;
            ry--;
            if(rx>=0 && ry>=0 && bd[ry*8+rx]==c){
              num++;
              goto loop_end;
            }
          }
// down-left
          rx=x-1;
          ry=y+1;
          for(;;){
            if(rx<0 || ry>=8 || bd[ry*8+rx]!=rc)
              break;
            rx--;
            ry++;
            if(rx>=0 && ry<8 && bd[ry*8+rx]==c){
              num++;
              goto loop_end;
            }
          }
// up-right
          rx=x+1;
          ry=y-1;
          for(;;){
            if(rx>=8 || ry<0 || bd[ry*8+rx]!=rc)
              break;
            rx++;
            ry--;
            if(rx<8 && ry>=0 && bd[ry*8+rx]==c){
              num++;
              goto loop_end;
            }
          }
// down-right
          rx=x+1;
          ry=y+1;
          for(;;){
            if(rx>=8 || ry>=8 || bd[ry*8+rx]!=rc)
              break;
            rx++;
            ry++;
            if(rx<8 && ry<8 && bd[ry*8+rx]==c){
              num++;
              goto loop_end;
            }
          }
        loop_end:
    i=0;
        }
  }
  return(num);
}

bool put_on_board(char *bd,int x,int y,int c)
{
  int rx,ry,rc;
  bool do_rev;
  do_rev=false;
  if(bd[y*8+x]!=0)
          return(do_rev);
  if(c==1) rc=2;
        else  rc=1;
// up
  rx=x;
  ry=y-1;
        for(;;){
    if(ry<0 || bd[ry*8+rx]!=rc)
      break;
    ry--;
    if(ry>=0 && bd[ry*8+rx]==c){
      rx=x;
      ry=y-1;
      do{
        bd[ry*8+rx]=c;
        ry--;
      }while(bd[ry*8+rx]!=c);
      do_rev=true;
                        break;
                }
  }
// down
  rx=x;
  ry=y+1;
        for(;;){
    if(ry>=8 || bd[ry*8+rx]!=rc)
      break;
    ry++;
    if(ry<8 && bd[ry*8+rx]==c){
      rx=x;
      ry=y+1;
      do{
        bd[ry*8+rx]=c;
        ry++;
      }while(bd[ry*8+rx]!=c);
      do_rev=true;
                        break;
                }
  }
// left
  rx=x-1;
  ry=y;
        for(;;){
    if(rx<0 || bd[ry*8+rx]!=rc)
      break;
    rx--;
    if(rx>=0 && bd[ry*8+rx]==c){
      rx=x-1;
      ry=y;
      do{
        bd[ry*8+rx]=c;
        rx--;
      }while(bd[ry*8+rx]!=c);
      do_rev=true;
                        break;
    }
  }
// right
  rx=x+1;
  ry=y;
        for(;;){
    if(rx>=8 || bd[ry*8+rx]!=rc)
      break;
    rx++;
    if(rx<8 && bd[ry*8+rx]==c){
      rx=x+1;
      ry=y;
      do{
        bd[ry*8+rx]=c;
        rx++;
      }while(bd[ry*8+rx]!=c);
      do_rev=true;
                        break;
                }
  }
// up-left
  rx=x-1;
  ry=y-1;
        for(;;){
    if(rx<0 || ry<0 || bd[ry*8+rx]!=rc)
      break;
    rx--;
    ry--;
    if(rx>=0 && ry>=0 && bd[ry*8+rx]==c){
      rx=x-1;
      ry=y-1;
      do{
        bd[ry*8+rx]=c;
        rx--;
        ry--;
      }while(bd[ry*8+rx]!=c);
      do_rev=true;
                        break;
                }
  }
// down-left
  rx=x-1;
  ry=y+1;
        for(;;){
    if(rx<0 || ry>=8 || bd[ry*8+rx]!=rc)
      break;
    rx--;
    ry++;
    if(rx>=0 && ry<8 && bd[ry*8+rx]==c){
      rx=x-1;
      ry=y+1;
      do{
        bd[ry*8+rx]=c;
        rx--;
        ry++;
      }while(bd[ry*8+rx]!=c);
      do_rev=true;
                        break;
                }
  }
// up-right
  rx=x+1;
  ry=y-1;
        for(;;){
    if(rx>=8 || ry<0 || bd[ry*8+rx]!=rc)
      break;
    rx++;
    ry--;
    if(rx<8 && ry>=0 && bd[ry*8+rx]==c){
      rx=x+1;
      ry=y-1;
      do{
        bd[ry*8+rx]=c;
        rx++;
        ry--;
      }while(bd[ry*8+rx]!=c);
      do_rev=true;
                        break;
                }
  }
// down-right
  rx=x+1;
  ry=y+1;
        for(;;){
    if(rx>=8 || ry>=8 || bd[ry*8+rx]!=rc)
      break;
    rx++;
    ry++;
    if(rx<8 && ry<8 && bd[ry*8+rx]==c){
      rx=x+1;
      ry=y+1;
      do{
        bd[ry*8+rx]=c;
        rx++;
        ry++;
      }while(bd[ry*8+rx]!=c);
      do_rev=true;
                        break;
                }
  }
  if(do_rev==true)
    bd[y*8+x]=c;
  return(do_rev);
}

void think(char *bd,int *x,int *y,int c,int level)
{
  int rx,ry,p,maxx,maxy,maxp;

  maxp=-1000;
  for(ry=0;ry<8;ry++){
    for(rx=0;rx<8;rx++){
      if (can_put(bd, rx, ry, c)==false)
        continue;
      if (komasuu>=56 && level>=4)
        p=rev_point(bd, rx, ry, c, 8);
      else if (komasuu>=58 && level==3)
        p=rev_point(bd, rx, ry, c, 6);
      else if (komasuu>=60)
        p=rev_point(bd, rx, ry, c, 4);
      else
        p=rev_point(bd, rx, ry, c, level);
      if(p>maxp){
        maxx=rx;
        maxy=ry;
        maxp=p;
      }
    }
  }

  *x=maxx;
  *y=maxy;
  return;
}

static const int boardp[8][8]={
  32, -4, 4, 4, 4, 4, -4,32,
  -4,-16, 1, 1, 1, 1,-16,-4,
   4,  1, 1, 1, 1, 1,  1, 4,
   4,  1, 1, 1, 1, 1,  1, 4,
   4,  1, 1, 1, 1, 1,  1, 4,
   4,  1, 1, 1, 1, 1,  1, 4,
  -4,-16, 1, 1, 1, 1,-16,-4,
  32, -4, 4, 4, 4, 4, -4,32};

int rev_point(char *bd,int x,int y,int c,int level)
{
  char bdc[8][8];
  int num;
  int point;
  int rx, ry, rc, maxp, po;

  if(c==1) rc=2;
  else rc=1;

  if (put_num(bd, c)==0 && put_num(bd, rc)==0){
    num=0;
    for(ry=0;ry<8;ry++){
      for(rx=0;rx<8;rx++){
        if (bd[ry*8+rx]==c)
          num++;
        else if (bd[ry*8+rx]==rc)
          num--;
      }
    }
    return(num*8);
  }

  for(ry=0;ry<8;ry++)
    for(rx=0;rx<8;rx++)
      bdc[ry][rx]=bd[ry*8+rx];

  if(put_on_board(&bdc[0][0], x, y, c)==false)
    return(-500);

  if (level<=1){
    num=0;
    point=0;
    for(ry=0;ry<8;ry++){
      for(rx=0;rx<8;rx++){
        if (bdc[ry][rx]==c){
          num++;
          point=point+boardp[ry][rx];
        }else if(bdc[ry][rx]==rc){
          num--;
          point=point-boardp[ry][rx];
        }
      }
    }

    if(komasuu<30)
      po=((4-put_num(&bdc[0][0], rc))*4+point)*4+random(1, 8);
    else if(komasuu<56)
      po=((4-put_num(&bdc[0][0], rc))+point)*4+random(1, 8);
    else
      po=num*8;

    return(po);
  }

  maxp=-1000;
  for(ry=0;ry<8;ry++){
    for(rx=0;rx<8;rx++){
      po=rev_point(&bdc[0][0], rx, ry, rc, level-1);
      if (po>maxp)
        maxp=po;
    }
  }
  if (maxp==-1000)
    maxp=0;
  return(-maxp);
}
